*** a/src/backend/parser/parse_func.c
--- b/src/backend/parser/parse_func.c
***************
*** 17,32 ****
--- 17,35 ----
  #include "access/htup_details.h"
  #include "catalog/pg_proc.h"
  #include "catalog/pg_type.h"
+ #include "catalog/pg_aggregate.h"
  #include "funcapi.h"
  #include "lib/stringinfo.h"
  #include "nodes/makefuncs.h"
  #include "nodes/nodeFuncs.h"
  #include "parser/parse_agg.h"
+ #include "parser/parse_clause.h"
  #include "parser/parse_coerce.h"
  #include "parser/parse_func.h"
  #include "parser/parse_relation.h"
  #include "parser/parse_target.h"
  #include "parser/parse_type.h"
+ #include "parser/parse_expr.h"
  #include "utils/builtins.h"
  #include "utils/lsyscache.h"
  #include "utils/syscache.h"
***************
*** 56,70 **** static Node *ParseComplexProjection(ParseState *pstate, char *funcname,
   *	Also, when is_column is true, we return NULL on failure rather than
   *	reporting a no-such-function error.
   *
!  *	The argument expressions (in fargs) and filter must have been transformed
!  *	already.  But the agg_order expressions, if any, have not been.
   */
  Node *
  ParseFuncOrColumn(ParseState *pstate, List *funcname, List *fargs,
! 				  List *agg_order, Expr *agg_filter,
! 				  bool agg_star, bool agg_distinct, bool func_variadic,
! 				  WindowDef *over, bool is_column, int location)
  {
  	Oid			rettype;
  	Oid			funcid;
  	ListCell   *l;
--- 59,79 ----
   *	Also, when is_column is true, we return NULL on failure rather than
   *	reporting a no-such-function error.
   *
!  *	The argument expressions (in fargs) must have been transformed
!  *	already.
   */
  Node *
  ParseFuncOrColumn(ParseState *pstate, List *funcname, List *fargs,
! 				  int location, FuncCall *fn)
  {
+ 	List       *agg_order = (fn ? fn->agg_order : NIL);
+ 	Expr       *agg_filter = NULL;
+ 	bool        agg_star = (fn ? fn->agg_star : false);
+ 	bool        agg_distinct = (fn ? fn->agg_distinct : false);
+ 	bool        agg_within_group = (fn ? fn->has_within_group : false);
+ 	bool        func_variadic = (fn ? fn->func_variadic : false);
+ 	WindowDef  *over = (fn ? fn->over : NULL);
+ 	bool        is_column = (fn == NULL);
  	Oid			rettype;
  	Oid			funcid;
  	ListCell   *l;
***************
*** 81,86 **** ParseFuncOrColumn(ParseState *pstate, List *funcname, List *fargs,
--- 90,101 ----
  	int			nvargs;
  	Oid			vatype;
  	FuncDetailCode fdresult;
+ 	int		number_of_args = -1;
+ 	bool		isordsetfunc = false;
+ 	bool		ishypotheticalsetfunc = false;
+ 
+ 	/* Check if the function has WITHIN GROUP as well as distinct. */
+ 	Assert(!(agg_within_group && agg_distinct));
  
  	/*
  	 * Most of the rest of the parser just assumes that functions do not have
***************
*** 98,103 **** ParseFuncOrColumn(ParseState *pstate, List *funcname, List *fargs,
--- 113,127 ----
  				 parser_errposition(pstate, location)));
  
  	/*
+ 	 * Transform the aggregate filter using transformWhereClause(), to which
+ 	 * FILTER is virtually identical...
+ 	 */
+ 	if (fn && fn->agg_filter != NULL)
+ 		agg_filter = (Expr *)
+ 			transformWhereClause(pstate, (Node *) fn->agg_filter,
+ 								 EXPR_KIND_FILTER, "FILTER");
+ 
+ 	/*
  	 * Extract arg type info in preparation for function lookup.
  	 *
  	 * If any arguments are Param markers of type VOID, we discard them from
***************
*** 163,168 **** ParseFuncOrColumn(ParseState *pstate, List *funcname, List *fargs,
--- 187,198 ----
  		}
  	}
  
+ 	if (agg_within_group && argnames)
+ 		ereport(ERROR,
+ 				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+ 				 errmsg("ordered set functions cannot use named arguments"),
+ 				 parser_errposition(pstate, location)));
+ 
  	if (fargs)
  	{
  		first_arg = linitial(fargs);
***************
*** 170,175 **** ParseFuncOrColumn(ParseState *pstate, List *funcname, List *fargs,
--- 200,225 ----
  	}
  
  	/*
+ 	 * If WITHIN GROUP is present, we need to call transformExpr on each
+ 	 * SortBy node in agg_order, then call exprType and append to
+ 	 * actual_arg_types, in order to get the types of values in WITHIN GROUP
+ 	 * clause.
+ 	 */
+ 	if (agg_within_group)
+ 	{
+ 		Assert(agg_order != NIL);
+ 
+ 		foreach(l, agg_order)
+ 		{
+ 			SortBy	   *arg = (SortBy *) lfirst(l);
+ 
+ 			arg->node = transformExpr(pstate, arg->node, EXPR_KIND_ORDER_BY);
+ 
+ 			actual_arg_types[nargs++] = exprType(arg->node);
+ 		}
+ 	}
+ 
+ 	/*
  	 * Check for column projection: if function has one argument, and that
  	 * argument is of complex type, and function name is not qualified, then
  	 * the "function call" could be a projection.  We also check that there
***************
*** 247,252 **** ParseFuncOrColumn(ParseState *pstate, List *funcname, List *fargs,
--- 297,308 ----
  			errmsg("DISTINCT specified, but %s is not an aggregate function",
  				   NameListToString(funcname)),
  					 parser_errposition(pstate, location)));
+ 		if (agg_within_group)
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_WRONG_OBJECT_TYPE),
+ 			errmsg("WITHIN GROUP specified, but %s is not an ordered set function",
+ 				   NameListToString(funcname)),
+ 					 parser_errposition(pstate, location)));
  		if (agg_order != NIL)
  			ereport(ERROR,
  					(errcode(ERRCODE_WRONG_OBJECT_TYPE),
***************
*** 266,271 **** ParseFuncOrColumn(ParseState *pstate, List *funcname, List *fargs,
--- 322,373 ----
  							NameListToString(funcname)),
  					 parser_errposition(pstate, location)));
  	}
+ 	else if (fdresult == FUNCDETAIL_AGGREGATE)
+ 	{
+ 		HeapTuple	tup;
+ 		Form_pg_aggregate classForm;
+ 
+ 		tup = SearchSysCache1(AGGFNOID, ObjectIdGetDatum(funcid));
+ 		if (!HeapTupleIsValid(tup)) /* should not happen */
+ 			elog(ERROR, "cache lookup failed for aggregate %u", funcid);
+ 
+ 		classForm = (Form_pg_aggregate) GETSTRUCT(tup);
+ 		isordsetfunc = classForm->aggisordsetfunc;
+ 
+ 		if (isordsetfunc)
+ 		{
+ 			if (classForm->aggordnargs == -2)
+ 			{
+ 				ishypotheticalsetfunc = true;
+ 
+ 				if (nvargs != 2*list_length(agg_order))
+ 					ereport(ERROR,
+ 							(errcode(ERRCODE_WRONG_OBJECT_TYPE),
+ 							 errmsg("Incorrect number of arguments for hypothetical set function"),
+ 							 parser_errposition(pstate, location)));
+ 			}
+ 			else
+ 			{
+ 				number_of_args = classForm->aggordnargs;
+ 			}
+ 
+ 			if (!agg_within_group)
+ 				ereport(ERROR,
+ 						(errcode(ERRCODE_WRONG_OBJECT_TYPE),
+ 						 errmsg("WITHIN GROUP is required for call to ordered set function %s",
+ 								NameListToString(funcname)),
+ 						 parser_errposition(pstate, location)));
+ 		
+ 			if (over)
+ 				ereport(ERROR,
+ 						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+ 						 errmsg("OVER clause not supported for call to ordered set function %s",
+ 								NameListToString(funcname)),
+ 						 parser_errposition(pstate, location)));
+ 		}
+ 
+ 		ReleaseSysCache(tup);
+ 	}
  	else if (!(fdresult == FUNCDETAIL_AGGREGATE ||
  			   fdresult == FUNCDETAIL_WINDOWFUNC))
  	{
***************
*** 351,363 **** ParseFuncOrColumn(ParseState *pstate, List *funcname, List *fargs,
  											   false);
  
  	/* perform the necessary typecasting of arguments */
! 	make_fn_arguments(pstate, fargs, actual_arg_types, declared_arg_types);
  
  	/*
  	 * If it's a variadic function call, transform the last nvargs arguments
  	 * into an array --- unless it's an "any" variadic.
  	 */
! 	if (nvargs > 0 && declared_arg_types[nargs - 1] != ANYOID)
  	{
  		ArrayExpr  *newa = makeNode(ArrayExpr);
  		int			non_var_args = nargs - nvargs;
--- 453,468 ----
  											   false);
  
  	/* perform the necessary typecasting of arguments */
! 	make_fn_arguments(pstate, fargs, (isordsetfunc) ? agg_order : NIL, 
! 					  actual_arg_types, 
! 					  declared_arg_types,
! 					  ishypotheticalsetfunc);
  
  	/*
  	 * If it's a variadic function call, transform the last nvargs arguments
  	 * into an array --- unless it's an "any" variadic.
  	 */
! 	if (nvargs > 0 && vatype != ANYOID)
  	{
  		ArrayExpr  *newa = makeNode(ArrayExpr);
  		int			non_var_args = nargs - nvargs;
***************
*** 388,403 **** ParseFuncOrColumn(ParseState *pstate, List *funcname, List *fargs,
  	 * When function is called with an explicit VARIADIC labeled parameter,
  	 * and the declared_arg_type is "any", then sanity check the actual
  	 * parameter type now - it must be an array.
  	 */
  	if (nargs > 0 && vatype == ANYOID && func_variadic)
  	{
! 		Oid		va_arr_typid = actual_arg_types[nargs - 1];
  
  		if (!OidIsValid(get_element_type(va_arr_typid)))
  			ereport(ERROR,
  					(errcode(ERRCODE_DATATYPE_MISMATCH),
  					 errmsg("VARIADIC argument must be an array"),
! 			  parser_errposition(pstate, exprLocation((Node *) llast(fargs)))));
  	}
  
  	/* build the appropriate output structure */
--- 493,523 ----
  	 * When function is called with an explicit VARIADIC labeled parameter,
  	 * and the declared_arg_type is "any", then sanity check the actual
  	 * parameter type now - it must be an array.
+ 	 *
+ 	 * Also, it can't be a hypothetical set function, and if it's an ordered
+ 	 * set function, the variadic labeled parameter is the last _direct_ arg,
+ 	 * not an ordered arg. (In practice we're unlikely to get this far for
+ 	 * hypotheticals, since make_fn_arguments would probably fail to unify
+ 	 * types, but we can't change the order of these.)
  	 */
  	if (nargs > 0 && vatype == ANYOID && func_variadic)
  	{
! 		int     ignore_args = (agg_within_group ? list_length(agg_order) : 0);
! 		Oid		va_arr_typid = actual_arg_types[nargs - 1 - ignore_args];
! 
! 		if (ishypotheticalsetfunc)
! 			ereport(ERROR,
! 					(errcode(ERRCODE_SYNTAX_ERROR),
! 			  errmsg("explicit VARIADIC argument not allowed for hypothetical set function"),
! 			  parser_errposition(pstate,
! 								 exprLocation((Node *) list_nth(fargs, nargs - 1 - ignore_args)))));
  
  		if (!OidIsValid(get_element_type(va_arr_typid)))
  			ereport(ERROR,
  					(errcode(ERRCODE_DATATYPE_MISMATCH),
  					 errmsg("VARIADIC argument must be an array"),
! 			  parser_errposition(pstate,
! 								 exprLocation((Node *) list_nth(fargs, nargs - 1 - ignore_args)))));
  	}
  
  	/* build the appropriate output structure */
***************
*** 421,426 **** ParseFuncOrColumn(ParseState *pstate, List *funcname, List *fargs,
--- 541,552 ----
  		/* aggregate function */
  		Aggref	   *aggref = makeNode(Aggref);
  
+ 		if (agg_within_group && !isordsetfunc)
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_WRONG_OBJECT_TYPE),
+ 					 errmsg("%s is not an ordered set function",
+ 							func_signature_string(funcname, nargs, NIL, actual_arg_types))));
+ 
  		aggref->aggfnoid = funcid;
  		aggref->aggtype = rettype;
  		/* aggcollid and inputcollid will be set by parse_collate.c */
***************
*** 428,441 **** ParseFuncOrColumn(ParseState *pstate, List *funcname, List *fargs,
  		aggref->aggfilter = agg_filter;
  		aggref->aggstar = agg_star;
  		aggref->aggvariadic = func_variadic;
  		/* agglevelsup will be set by transformAggregateCall */
  		aggref->location = location;
  
  		/*
  		 * Reject attempt to call a parameterless aggregate without (*)
  		 * syntax.	This is mere pedantry but some folks insisted ...
  		 */
! 		if (fargs == NIL && !agg_star)
  			ereport(ERROR,
  					(errcode(ERRCODE_WRONG_OBJECT_TYPE),
  					 errmsg("%s(*) must be used to call a parameterless aggregate function",
--- 554,577 ----
  		aggref->aggfilter = agg_filter;
  		aggref->aggstar = agg_star;
  		aggref->aggvariadic = func_variadic;
+ 		aggref->ishypothetical = ishypotheticalsetfunc;
  		/* agglevelsup will be set by transformAggregateCall */
  		aggref->location = location;
  
+ 		if (isordsetfunc
+ 			&& number_of_args >= 0
+ 			&& number_of_args != list_length(fargs))
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_WRONG_OBJECT_TYPE),
+ 					 errmsg("Incorrect number of direct arguments to ordered set function %s",
+ 							NameListToString(funcname)),
+ 					 parser_errposition(pstate, location)));
+ 
  		/*
  		 * Reject attempt to call a parameterless aggregate without (*)
  		 * syntax.	This is mere pedantry but some folks insisted ...
  		 */
! 		if (fargs == NIL && !agg_star && !agg_within_group)
  			ereport(ERROR,
  					(errcode(ERRCODE_WRONG_OBJECT_TYPE),
  					 errmsg("%s(*) must be used to call a parameterless aggregate function",
***************
*** 464,470 **** ParseFuncOrColumn(ParseState *pstate, List *funcname, List *fargs,
  					 parser_errposition(pstate, location)));
  
  		/* parse_agg.c does additional aggregate-specific processing */
! 		transformAggregateCall(pstate, aggref, fargs, agg_order, agg_distinct);
  
  		retval = (Node *) aggref;
  	}
--- 600,607 ----
  					 parser_errposition(pstate, location)));
  
  		/* parse_agg.c does additional aggregate-specific processing */
! 		transformAggregateCall(pstate, aggref, fargs, agg_order,
! 							   agg_distinct, agg_within_group);
  
  		retval = (Node *) aggref;
  	}
***************
*** 473,478 **** ParseFuncOrColumn(ParseState *pstate, List *funcname, List *fargs,
--- 610,621 ----
  		/* window function */
  		WindowFunc *wfunc = makeNode(WindowFunc);
  
+ 		if (agg_within_group)
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_WRONG_OBJECT_TYPE),
+ 					 errmsg("WITHIN GROUP not allowed in window functions"),
+ 					 parser_errposition(pstate, location)));
+ 
  		/*
  		 * True window functions must be called with a window definition.
  		 */
***************
*** 1374,1384 **** func_get_detail(List *funcname,
  void
  make_fn_arguments(ParseState *pstate,
  				  List *fargs,
  				  Oid *actual_arg_types,
! 				  Oid *declared_arg_types)
  {
  	ListCell   *current_fargs;
  	int			i = 0;
  
  	foreach(current_fargs, fargs)
  	{
--- 1517,1537 ----
  void
  make_fn_arguments(ParseState *pstate,
  				  List *fargs,
+ 				  List *agg_order,
  				  Oid *actual_arg_types,
! 				  Oid *declared_arg_types,
! 				  bool requiresUnification)
  {
  	ListCell   *current_fargs;
+ 	ListCell   *current_aoargs;
  	int			i = 0;
+ 	int         unify_offset = -1;
+ 
+ 	if (requiresUnification)
+ 	{
+ 		unify_offset = list_length(fargs) - list_length(agg_order);
+ 		Assert(unify_offset >= 0);
+ 	}
  
  	foreach(current_fargs, fargs)
  	{
***************
*** 1386,1391 **** make_fn_arguments(ParseState *pstate,
--- 1539,1545 ----
  		if (actual_arg_types[i] != declared_arg_types[i])
  		{
  			Node	   *node = (Node *) lfirst(current_fargs);
+ 			Node       *temp = NULL;
  
  			/*
  			 * If arg is a NamedArgExpr, coerce its input expr instead --- we
***************
*** 1406,1423 **** make_fn_arguments(ParseState *pstate,
  			}
  			else
  			{
! 				node = coerce_type(pstate,
! 								   node,
! 								   actual_arg_types[i],
! 								   declared_arg_types[i], -1,
! 								   COERCION_IMPLICIT,
! 								   COERCE_IMPLICIT_CAST,
! 								   -1);
! 				lfirst(current_fargs) = node;
  			}
  		}
  		i++;
  	}
  }
  
  /*
--- 1560,1625 ----
  			}
  			else
  			{
! 				/* 
! 				 * If we are dealing with a hypothetical set function, we
! 				 * need to unify agg_order and fargs.
! 				 */
! 
! 				if (declared_arg_types[i] == ANYOID && requiresUnification)
! 				{
! 					Oid unification_oid;
! 					SortBy *unify_with = (SortBy *) list_nth(agg_order,i - unify_offset);
! 
! 					unification_oid = select_common_type(pstate,
! 														 list_make2(unify_with->node,node),
! 														 "WITHIN GROUP",
! 														 NULL);
! 
! 					declared_arg_types[i + list_length(agg_order)] = unification_oid;
! 
! 					temp = coerce_type(pstate,
! 									   node,
! 									   actual_arg_types[i],
! 									   unification_oid, -1,
! 									   COERCION_IMPLICIT,
! 									   COERCE_IMPLICIT_CAST,
! 									   -1);
! 				}
! 				else
! 				{
! 					temp = coerce_type(pstate,
! 									   node,
! 									   actual_arg_types[i],
! 									   declared_arg_types[i], -1,
! 									   COERCION_IMPLICIT,
! 									   COERCE_IMPLICIT_CAST,
! 									   -1);
! 				}
! 
! 				lfirst(current_fargs) = temp;
  			}
  		}
  		i++;
  	}
+ 
+ 	foreach(current_aoargs, agg_order)
+ 	{
+ 		if (actual_arg_types[i] != declared_arg_types[i])
+ 		{
+ 			SortBy	   *node = (SortBy *) lfirst(current_aoargs);
+ 			Node       *temp = NULL;
+ 
+ 			temp = coerce_type(pstate,
+ 							   node->node,
+ 							   actual_arg_types[i],
+ 							   declared_arg_types[i], -1,
+ 							   COERCION_IMPLICIT,
+ 							   COERCE_IMPLICIT_CAST,
+ 							   -1);
+ 			node->node = temp;
+ 		}
+ 		i++;
+ 	}
  }
  
  /*
*** a/src/backend/parser/parse_oper.c
--- b/src/backend/parser/parse_oper.c
***************
*** 823,829 **** make_op(ParseState *pstate, List *opname, Node *ltree, Node *rtree,
  											   false);
  
  	/* perform the necessary typecasting of arguments */
! 	make_fn_arguments(pstate, args, actual_arg_types, declared_arg_types);
  
  	/* and build the expression node */
  	result = makeNode(OpExpr);
--- 823,829 ----
  											   false);
  
  	/* perform the necessary typecasting of arguments */
! 	make_fn_arguments(pstate, args, NULL, actual_arg_types, declared_arg_types, false);
  
  	/* and build the expression node */
  	result = makeNode(OpExpr);
***************
*** 953,959 **** make_scalar_array_op(ParseState *pstate, List *opname,
  	declared_arg_types[1] = res_atypeId;
  
  	/* perform the necessary typecasting of arguments */
! 	make_fn_arguments(pstate, args, actual_arg_types, declared_arg_types);
  
  	/* and build the expression node */
  	result = makeNode(ScalarArrayOpExpr);
--- 953,959 ----
  	declared_arg_types[1] = res_atypeId;
  
  	/* perform the necessary typecasting of arguments */
! 	make_fn_arguments(pstate, args, NULL, actual_arg_types, declared_arg_types, false);
  
  	/* and build the expression node */
  	result = makeNode(ScalarArrayOpExpr);
*** a/src/backend/utils/adt/Makefile
--- b/src/backend/utils/adt/Makefile
***************
*** 19,31 **** OBJS = acl.o arrayfuncs.o array_selfuncs.o array_typanalyze.o \
  	array_userfuncs.o arrayutils.o bool.o \
  	cash.o char.o date.o datetime.o datum.o domains.o \
  	enum.o float.o format_type.o \
! 	geo_ops.o geo_selfuncs.o int.o int8.o json.o jsonfuncs.o like.o \
  	lockfuncs.o misc.o nabstime.o name.o numeric.o numutils.o \
  	oid.o oracle_compat.o pseudotypes.o rangetypes.o rangetypes_gist.o \
  	rowtypes.o regexp.o regproc.o ruleutils.o selfuncs.o \
  	tid.o timestamp.o varbit.o varchar.o varlena.o version.o xid.o \
  	network.o mac.o inet_cidr_ntop.o inet_net_pton.o \
! 	ri_triggers.o pg_lzcompress.o pg_locale.o formatting.o \
  	ascii.o quote.o pgstatfuncs.o encode.o dbsize.o genfile.o trigfuncs.o \
  	tsginidx.o tsgistidx.o tsquery.o tsquery_cleanup.o tsquery_gist.o \
  	tsquery_op.o tsquery_rewrite.o tsquery_util.o tsrank.o \
--- 19,31 ----
  	array_userfuncs.o arrayutils.o bool.o \
  	cash.o char.o date.o datetime.o datum.o domains.o \
  	enum.o float.o format_type.o \
! 	geo_ops.o geo_selfuncs.o hypotheticalset.o int.o int8.o json.o jsonfuncs.o like.o \
  	lockfuncs.o misc.o nabstime.o name.o numeric.o numutils.o \
  	oid.o oracle_compat.o pseudotypes.o rangetypes.o rangetypes_gist.o \
  	rowtypes.o regexp.o regproc.o ruleutils.o selfuncs.o \
  	tid.o timestamp.o varbit.o varchar.o varlena.o version.o xid.o \
  	network.o mac.o inet_cidr_ntop.o inet_net_pton.o \
! 	inversedistribution.o ri_triggers.o pg_lzcompress.o pg_locale.o formatting.o \
  	ascii.o quote.o pgstatfuncs.o encode.o dbsize.o genfile.o trigfuncs.o \
  	tsginidx.o tsgistidx.o tsquery.o tsquery_cleanup.o tsquery_gist.o \
  	tsquery_op.o tsquery_rewrite.o tsquery_util.o tsrank.o \
*** /dev/null
--- b/src/backend/utils/adt/hypotheticalset.c
***************
*** 0 ****
--- 1,219 ----
+ /*-------------------------------------------------------------------------
+  *
+  * hypotheticalset.c
+  *	  Hypothetical set functions.
+  *
+  * Portions Copyright (c) 1996-2013, PostgreSQL Global Development Group
+  * Portions Copyright (c) 1994, Regents of the University of California
+  *
+  *
+  * IDENTIFICATION
+  *	  src/backend/utils/adt/hypotheticalset.c
+  *
+  *-------------------------------------------------------------------------
+  */
+ #include "postgres.h"
+ #include "fmgr.h"
+ #include <string.h>
+ #include <math.h>
+ 
+ #include "utils/tuplesort.h"
+ #include "catalog/pg_type.h"
+ #include "utils/datetime.h"
+ #include "utils/builtins.h"
+ #include "executor/executor.h"
+ 
+ Datum hypothetical_rank_final(PG_FUNCTION_ARGS);
+ Datum hypothetical_dense_rank_final(PG_FUNCTION_ARGS);
+ Datum hypothetical_percent_rank_final(PG_FUNCTION_ARGS);
+ Datum hypothetical_cume_dist_final(PG_FUNCTION_ARGS);
+ 
+ 
+ /*
+  * Common code to sanity-check args for hypothetical set functions. No need
+  * for friendly errors, these can only happen if someone's messing up the
+  * aggregate definitions. The checks are needed for security, however; but we
+  * only need them once per call site.  Store a pointer to the tupdesc as a
+  * sentinel.
+  */
+ 
+ static void
+ hypothetical_check_argtypes(FunctionCallInfo fcinfo, int nargs, TupleDesc tupdesc)
+ {
+ 	int i;
+ 
+ 	if (!tupdesc
+ 		|| (nargs + 1) != tupdesc->natts
+ 		|| tupdesc->attrs[nargs]->atttypid != BOOLOID)
+ 		elog(ERROR, "type mismatch in hypothetical set function");
+ 
+ 	for (i = 0; i < nargs; ++i)
+ 		if (get_fn_expr_argtype(fcinfo->flinfo,i) != tupdesc->attrs[i]->atttypid)
+ 			elog(ERROR, "type mismatch in hypothetical set function");
+ 
+ 	fcinfo->flinfo->fn_extra = tupdesc;
+ }
+ 
+ /*
+  * rank(float8)  - rank of hypothetical row
+  */
+ Datum
+ hypothetical_rank_final(PG_FUNCTION_ARGS)
+ {
+ 	Tuplesortstate *sorter = NULL;
+ 	TupleDesc	tupdesc = NULL;
+     TupleTableSlot *slot = NULL;
+ 	Oid			datumtype = InvalidOid;
+ 	int			nargs = PG_NARGS();
+ 	int			i;
+ 	int64		rank = 1;
+ 
+ 	AggSetGetSortInfo(fcinfo, &sorter, &tupdesc, &slot, &datumtype);
+ 
+ 	if (fcinfo->flinfo->fn_extra == NULL
+ 		|| fcinfo->flinfo->fn_extra != tupdesc)
+ 		hypothetical_check_argtypes(fcinfo, nargs, tupdesc);
+ 
+ 	/* insert the hypothetical row into the sort */
+ 
+ 	ExecClearTuple(slot);
+ 	for (i = 0; i < nargs; ++i)
+ 	{
+ 		slot->tts_values[i] = PG_GETARG_DATUM(i);
+ 		slot->tts_isnull[i] = PG_ARGISNULL(i);
+ 	}
+ 	slot->tts_values[nargs] = BoolGetDatum(true);
+ 	slot->tts_isnull[nargs] = false;
+ 	ExecStoreVirtualTuple(slot);
+ 
+ 	tuplesort_puttupleslot(sorter, slot);
+ 
+ 	tuplesort_performsort(sorter);
+ 
+ 	while (tuplesort_gettupleslot(sorter, true, slot))
+ 	{
+ 		bool isnull;
+ 		Datum d = slot_getattr(slot, nargs + 1, &isnull);
+ 
+ 		if (!isnull && DatumGetBool(d))
+ 			break;
+ 
+ 		++rank;
+ 	}
+ 
+ 	ExecClearTuple(slot);
+ 
+ 	PG_RETURN_INT64(rank);
+ }
+ 
+ /*
+  * dense_rank(float8)  - rank of hypothetical row
+  *                       without gap in ranking
+  */
+ Datum
+ hypothetical_dense_rank_final(PG_FUNCTION_ARGS)
+ {
+ 	Tuplesortstate *sorter = NULL;
+ 	TupleDesc	tupdesc = NULL;
+     TupleTableSlot *slot = NULL;
+ 	Oid			datumtype = InvalidOid;
+ 	int			nargs = PG_NARGS();
+ 	int			i;
+ 	int64		rank = 1;
+ 	int			duplicate_count = 0;
+ 	TupleTableSlot *slot2 = NULL;
+ 	AttrNumber *colidx;
+ 	FmgrInfo   *equalfns;
+ 	int			numDistinctCol = 0;
+ 	MemoryContext memcontext;
+ 
+ 	AggSetGetSortInfo(fcinfo, &sorter, &tupdesc, &slot, &datumtype);
+ 
+ 	if (fcinfo->flinfo->fn_extra == NULL
+ 		|| fcinfo->flinfo->fn_extra != tupdesc)
+ 		hypothetical_check_argtypes(fcinfo, nargs, tupdesc);
+ 
+ 	/* insert the hypothetical row into the sort */
+ 
+ 	ExecClearTuple(slot);
+ 	for (i = 0; i < nargs; ++i)
+ 	{
+ 		slot->tts_values[i] = PG_GETARG_DATUM(i);
+ 		slot->tts_isnull[i] = PG_ARGISNULL(i);
+ 	}
+ 	slot->tts_values[nargs] = BoolGetDatum(true);
+ 	slot->tts_isnull[nargs] = false;
+ 	ExecStoreVirtualTuple(slot);
+ 
+ 	tuplesort_puttupleslot(sorter, slot);
+ 
+ 	tuplesort_performsort(sorter);
+ 
+ 	numDistinctCol = AggSetGetDistinctInfo(fcinfo, &slot2, &colidx, &equalfns);
+ 
+ 	ExecClearTuple(slot2);
+ 
+ 	AggSetGetPerTupleContext(fcinfo, &memcontext);
+ 
+ 	while (tuplesort_gettupleslot(sorter, true, slot))
+ 	{
+ 		TupleTableSlot *tmpslot = slot2;
+ 		bool isnull;
+ 		Datum d = slot_getattr(slot, nargs + 1, &isnull);
+ 
+ 		if (!isnull && DatumGetBool(d))
+ 			break;
+ 
+ 		if (!TupIsNull(slot2)
+ 			&& execTuplesMatch(slot, slot2,
+ 							   (numDistinctCol - 1),
+ 							   colidx,
+ 							   equalfns,
+ 							   memcontext))
+ 			++duplicate_count;
+ 
+ 		slot2 = slot;
+ 		slot = tmpslot;
+ 
+ 		++rank;
+ 	}
+ 
+ 	ExecClearTuple(slot);
+ 	ExecClearTuple(slot2);
+ 
+ 	rank = rank - duplicate_count;
+ 	PG_RETURN_INT64(rank);
+ }
+ 
+ /* percent_rank(float8)
+  * Calculates the relative ranking of hypothetical
+  * row within a group
+  */
+ 
+ Datum
+ hypothetical_percent_rank_final(PG_FUNCTION_ARGS)
+ {
+ 	Datum		rank     = hypothetical_rank_final(fcinfo);
+ 	int64		rank_val = DatumGetInt64(rank);
+ 	int64		rowcount = AggSetGetRowCount(fcinfo) + 1;
+ 
+ 	float8 result_val = (float8) (rank_val - 1) / (float8) (rowcount - 1);
+ 
+ 	PG_RETURN_FLOAT8(result_val);
+ }
+ 
+ /* cume_dist - cumulative distribution of hypothetical
+  * row in a group
+  */
+ 
+ Datum
+ hypothetical_cume_dist_final(PG_FUNCTION_ARGS)
+ {
+ 	Datum		rank     = hypothetical_rank_final(fcinfo);
+ 	int64		rank_val = DatumGetInt64(rank);
+ 	int64		rowcount = AggSetGetRowCount(fcinfo) + 1;
+ 
+ 	float8 result_val = (float8) (rank_val) / (float8) (rowcount);
+ 
+ 	PG_RETURN_FLOAT8(result_val);
+ }
